#!/usr/bin/perl
#######################################################################
#                              N L S . P L
#           Copyright (C) 1998 by Jaroslav Benkovsky, PVT a.s.
#                     e-mail: benkovsk@pha.pvt.cz
#
#                            $Revision: 1.2 $
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# NLS - routines to change string encoding
#
# Please, do mail me any bug you experience or find, particularly
# if it can compromise website security. Thanks.
#
# RCS: $Header: /home/benkovsk/worx/lib/perl/RCS/nls.pl,v 1.2 1998/10/12 13:38:12 benkovsk Exp benkovsk $
#
#######################################################################

package nls;

$XLAT_CP_1250		= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
$XLAT_ISO_8859_2	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
$XLAT_MAC		= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
$XLAT_ASCII		= "AABCCDDEEEFGHIIJKLMNNOOPQRRSSTTUUUVWXYYZZaabccddeeefghiijklmnnoopqrrssttuuuvwxyyzz";
$XLAT_CP_852		= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
$XLAT_KEYBCS2		= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
$XLAT_KOI8_CS		= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

$XLAT_ISO_8859_2_UP	= "ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZ";

$XLAT_ASCII_UP          = "AABCCDDEEEFGHIIJKLMNNOOPQRRSSTTUUUVWXYYZZAABCCDDEEEFGHIIJKLMNNOOPQRRSSTTUUUVWXYYZZ";

my %XlatList = (
	     'ISO-8859-2' => $XLAT_ISO_8859_2,
	     'CP-1250' => $XLAT_CP_1250,
	     'MAC' => $XLAT_MAC,
	     'ASCII' => $XLAT_ASCII,
	     'CP-852' => $XLAT_CP_852,
	     'KEYBCS2' => $XLAT_KEYBCS2,
	     'KOI8-CS' => $XLAT_KOI8_CS,

	     'ISO-8859-2-UP' => $XLAT_ISO_8859_2_UP,
	     'ASCII_UP' => $XLAT_ASCII_UP
	     );

my %CharsetAlias = (
		 'iso' => 'ISO-8859-2',
		 'iso-8859-2' => 'ISO-8859-2',
		 'win' => 'CP-1250',
		 'windows-1250' => 'CP-1250',
		 'lat' => 'CP-852',
		 '852' => 'CP-852',
		 'cp852' => 'CP-852',
		 'x-kam-cs' => 'KEYBCS2',
		 'kam' => 'KEYBCS2',
		 'x-mac-ce' => 'MAC',
		 'mac' => 'MAC',
		 'CSN_369103' => 'KOI8-CS',
		 'koi' => 'KOI8-CS',
		 'US-ASCII' => 'ASCII',
		 'asc' => 'ASCII',
		 'ascii' => 'ASCII'
		 );


$NLS_TGT_XLAT_TAG	= "HTTP_NLS_TGT_SET";
$NLS_TGT_CHARSET_TAG	= "HTTP_NLS_TGT_ALIAS1";

$XLAT_INT		= $XLAT_ISO_8859_2;
$XLAT_SRC		= $XLAT_ASCII;
$XLAT_TGT		= $XLAT_INT;

$XLAT_ON                = 0;

#######################################################################
sub XlatString {
    my ($text, $SrcEnc, $TgtEnc) = @_;
    my ($newtext, $c, $x);
    
    return $text if (!defined($text) || !defined($SrcEnc) || !defined($TgtEnc));
    
    eval "\$text =~ tr/$SrcEnc/$TgtEnc/";			# SHIT!!!
    return $text;

    $newtext="";
    
    foreach (0 .. (length ($text) - 1)) {
        $c = chop ($text);
	$x = index ($SrcEnc, $c);
	$c = substr ($TgtEnc, $x, 1) if ($x >= 0);
	$newtext = $c . $newtext;
    }
    # $text =~ tr/$SrcEnc/$TgtEnc/;			# SHIT!!!
    return $newtext;
}

#######################################################################
sub GetXlat {
    my ($alias) = @_;
    my ($name);
    my ($xlat) = $XLAT_ISO_8859_2; 

    if (!defined ($alias)) { return $xlat; }

    $name = $CharsetAlias{$alias};
    if (!defined ($name)) { $name = $alias; }

    if (defined ($XlatList{$name})) { $xlat = $XlatList{$name}; }

    return $xlat;
}

#######################################################################
sub Convert {
    local(*line) = @_;
    
    if ($XLAT_ON) {
	$line=&XlatString($line, $XLAT_INT, $XLAT_TGT);
    }
}

#######################################################################
sub main'nlsprint {
    local ($text) = @_;
    
    if (!$nls'XLAT_ON) { 
        print $text;
	return;
    }
    
    print &nls'XlatString($text, $nls'XLAT_INT, $nls'XLAT_TGT);
}

#######################################################################
if ($nls = $ENV{$NLS_TGT_XLAT_TAG}) {
    $XLAT_TGT = $nls;
    $XLAT_SRC = $nls;
    $XLAT_ON  = 1;
}

if ($CHARSET = $ENV{$NLS_TGT_CHARSET_TAG}) {
    $CHARSET=" charset=$CHARSET";
}

#######################################################################
1;
#######################################################################
# End of file nls.pl
